# PyMulti

PyMulti is an open-source, advanced, and multi-purpose Python package.

Read the docs [here](https://aniketh-chavare.gitbook.io/pymulti).

## Package Information

**Name** - PyMulti</br>
**Version** - 1.0.7</br>
**Description** - PyMulti is an open-source, advanced, and multi-purpose Python package.</br>
**Author** - Aniketh Chavare</br>
**GitHub URL** - [https://github.com/Anikethc/PyMulti](https://github.com/Anikethc/PyMulti)</br>
**Pypi.org URL** - [https://pypi.org/project/PyMulti](https://pypi.org/project/PyMulti)</br>
**Docs URL** - [https://aniketh-chavare.gitbook.io/pymulti](https://aniketh-chavare.gitbook.io/pymulti)

## Changelog

Go to the `CHANGELOG.md` file to see the changelog.

## Credits

The source code, license, and other information about their open-source projects are below. I'm grateful to these developers for their contribution.

### <u><i>Tutorials/Web Pages</i></u>

1. How to detect license plates using OpenCV Python? (Shahid Akhtar Khan) - Visit [here](https://www.tutorialspoint.com/how-to-detect-license-plates-using-opencv-python).
2. How to Detect and Recognize Car License Plates Using Python (Denis Kuria) - Visit [here](https://www.makeuseof.com/python-car-license-plates-detect-and-recognize).
3. Vehicle Detection and Counting System using OpenCV (Aman Preet Gulati) - Visit [here](https://www.analyticsvidhya.com/blog/2021/12/vehicle-detection-and-counting-system-using-opencv).
4. Vehicle Detection using OpenCV (Vidhu Chaudhary) - Visit [here](https://www.codingninjas.com/codestudio/library/vehicle-detection-using-opencv).
5. How to detect humans in an image in OpenCV Python? (Shahid Akhtar Khan) - Visit [here](https://www.tutorialspoint.com/how-to-detect-humans-in-an-image-in-opencv-python).
6. Python Project – Real-time Human Detection & Counting (Data Flair) - Visit [here](https://data-flair.training/blogs/python-project-real-time-human-detection-counting).

### <u><i>Third-Party Programs</i></u>

1. SetVol.exe (Rob Latour) - Visit [here](https://github.com/roblatour/setvol).

### <u><i>Python Packages</i></u>

1. gingerit (Tim Kleinschmidt) - Visit [here](https://github.com/Azd325/gingerit).
2. freegames (Grant Jenks) - Visit [here](https://github.com/grantjenks/free-python-games).
3. requests (Python Software Foundation) - Visit [here](https://github.com/psf/requests).
4. randfacts (Tabulate) - Visit [here](https://github.com/TabulateJarl8/randfacts).
5. matplotlib (matplotlib) - Visit [here](https://github.com/matplotlib/matplotlib).
6. pyttsx3 (Natesh Bhat) - Visit [here](https://github.com/nateshmbhat/pyttsx3).
7. screen-brightness-control (Crozzers) - Visit [here](https://github.com/Crozzers/screen_brightness_control).
8. pyperclip (Al Sweigart) - Visit [here](https://github.com/asweigart/pyperclip).
9. PyAutoGUI (Al Sweigart) - Visit [here](https://github.com/asweigart/pyautogui).
10. opencv-python (OpenCV) - Visit [here](https://github.com/opencv/opencv-python).
11. imutils (PyImageSearch) - Visit [here](https://github.com/PyImageSearch/imutils).
12. numpy (Numpy.org) - Visit [here](https://github.com/numpy/numpy).
13. pytesseract (Matthias A Lee) - Visit [here](https://github.com/madmaze/pytesseract).
14. Pillow (Python-Pillow) - Visit [here](https://github.com/python-pillow/Pillow).

## License

Copyright 2023 Aniketh Chavare

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

## Conclusion

If you experience any problems or bugs, please go to the 'Issues' section and create an issue. I will look into it and resolve it ASAP.

I hope you liked the package. Thank you!